grk::grk_buf2d< T, A > Struct Template Reference

`#include <buffer.h>`

Inheritance diagram for grk::grk_buf2d< T, A >:

## Classes

struct | memcpy_from

## Public Member Functions

| grk_buf2d (T *buffer, bool ownsData, uint32_t w, uint32_t strd, uint32_t h)
| grk_buf2d (uint32_t w, uint32_t h)
| grk_buf2d (const grk_rect32 *b)
| grk_buf2d (const grk_rect32 &b)
| grk_buf2d (const grk_rect32 &b, bool useOrigin)
| grk_buf2d (void)
| grk_buf2d (const grk_buf2d &rhs)
grk_buf2d_simple< T > | simple (void) const
grk_buf2d_simple< float > | simpleF (void) const
grk_buf2d & | operator= (const grk_buf2d &rhs)
grk_buf2d & | operator= (const grk_buf2d *rhs)
virtual | ~grk_buf2d ()=default
bool | alloc2d (bool clear)
void | attach (T *buffer, uint32_t strd)
void | attach (grk_buf2d &rhs, uint32_t x, uint32_t y)
void | attach (grk_buf2d &rhs)
void | attach (grk_buf2d *rhs, uint32_t x, uint32_t y)
void | attach (grk_buf2d *rhs)
void | acquire (T *buffer, uint32_t strd)
void | transfer (T **buffer, uint32_t *strd)
bool | isWindowValid (grk_rect32 win)
| Returns whether window bounds are valid (non empty and within buffer bounds)
template<typename F >
void | copyFrom (const grk_buf2d &src, F filter)
template<typename F >
void | copyFrom (const grk_buf2d *src, F filter)
void | copyFrom (const grk_buf2d &src)
T * | getBuffer (void) const
T * | address (uint32_t x, uint32_t y)
Public Member Functions inherited from grk::grk_rect< uint32_t >
| grk_rect (uint32_t origin_x0, uint32_t origin_y0, uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (const grk_rect &rhs)
| grk_rect (const grk_rect *rhs)
| grk_rect (void)
virtual | ~grk_rect ()=default
grk_rect< uint32_t > & | setOrigin (uint32_t origx, uint32_t origy, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > &rhs, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > *rhs, bool absolute)
grk_rect< uint32_t > & | toRelative (void)
grk_rect< uint32_t > & | toAbsolute (void)
virtual void | print (void) const
std::string | boundsString () const
bool | valid (void) const
bool | empty (void) const
bool | contains (grk_pt< uint32_t > pt)
bool | contains (uint32_t x, uint32_t y)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > &rhs)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > *rhs)
bool | operator== (const grk_rect< uint32_t > &rhs) const
void | setRect (grk_rect< uint32_t > *rhs)
void | setRect (grk_rect< uint32_t > rhs)
grk_rect< uint32_t > | scaleDownCeil (uint32_t den) const
grk_rect< uint32_t > | scaleDownCeil (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scale (uint32_t scalex, uint32_t scaley) const
grk_rect< uint32_t > | scaleDown (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scaleDownPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | scaleDownPow2 (grk_pt< uint32_t > pow) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t power) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > *rhs) const
bool | isContainedIn (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > &rhs) const
grk_rect< uint32_t > & | clip_IN_PLACE (const grk_rect< uint32_t > &rhs)
bool | nonEmptyIntersection (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > &rhs) const
uint64_t | area (void) const
uint32_t | width () const
uint32_t | height () const
grk_line< uint32_t > | dimX () const
grk_line< uint32_t > | dimY () const
grk_rect< uint32_t > | pan (int64_t x, int64_t y) const
grk_rect< uint32_t > & | pan_IN_PLACE (int64_t x, int64_t y)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, grk_rect< uint32_t > bounds)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, grk_rect< uint32_t > bounds)
uint32_t | parityX (void) const
uint32_t | parityY (void) const

## Public Attributes

uint32_t | stride
Public Attributes inherited from grk::grk_rect< uint32_t >
bool | absoluteCoordinates
uint32_t | origin_x0
uint32_t | origin_y0
uint32_t | x0
uint32_t | y0
uint32_t | x1
uint32_t | y1

## Additional Inherited Members

Protected Member Functions inherited from grk::grk_buf< T, A >
| grk_buf (T *buffer, size_t off, size_t length, bool ownsData)
| grk_buf (T *buffer, size_t length)
| grk_buf ()
| grk_buf (T *buffer, size_t length, bool ownsData)
virtual | ~grk_buf ()
| grk_buf (const grk_buf &rhs)
grk_buf & | operator= (const grk_buf &rhs)
grk_buf & | operator= (const grk_buf *rhs)
bool | canRead (void)
T | read (void)
bool | write (T val)
bool | write (T *b, size_t size)
virtual bool | alloc (size_t length)
virtual void | dealloc ()
void | attach (T *buffer)
void | acquire (T *buffer)
void | transfer (T **buffer)
size_t | remainingLength (void)
void | incrementOffset (ptrdiff_t off)
T * | currPtr (void) const
Protected Member Functions inherited from grk::grk_rect< uint32_t >
| grk_rect (uint32_t origin_x0, uint32_t origin_y0, uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (const grk_rect &rhs)
| grk_rect (const grk_rect *rhs)
| grk_rect (void)
virtual | ~grk_rect ()=default
grk_rect< uint32_t > & | setOrigin (uint32_t origx, uint32_t origy, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > &rhs, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > *rhs, bool absolute)
grk_rect< uint32_t > & | toRelative (void)
grk_rect< uint32_t > & | toAbsolute (void)
virtual void | print (void) const
std::string | boundsString () const
bool | valid (void) const
bool | empty (void) const
bool | contains (grk_pt< uint32_t > pt)
bool | contains (uint32_t x, uint32_t y)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > &rhs)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > *rhs)
bool | operator== (const grk_rect< uint32_t > &rhs) const
void | setRect (grk_rect< uint32_t > *rhs)
void | setRect (grk_rect< uint32_t > rhs)
grk_rect< uint32_t > | scaleDownCeil (uint32_t den) const
grk_rect< uint32_t > | scaleDownCeil (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scale (uint32_t scalex, uint32_t scaley) const
grk_rect< uint32_t > | scaleDown (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scaleDownPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | scaleDownPow2 (grk_pt< uint32_t > pow) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t power) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > *rhs) const
bool | isContainedIn (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > &rhs) const
grk_rect< uint32_t > & | clip_IN_PLACE (const grk_rect< uint32_t > &rhs)
bool | nonEmptyIntersection (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > &rhs) const
uint64_t | area (void) const
uint32_t | width () const
uint32_t | height () const
grk_line< uint32_t > | dimX () const
grk_line< uint32_t > | dimY () const
grk_rect< uint32_t > | pan (int64_t x, int64_t y) const
grk_rect< uint32_t > & | pan_IN_PLACE (int64_t x, int64_t y)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, grk_rect< uint32_t > bounds)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, grk_rect< uint32_t > bounds)
uint32_t | parityX (void) const
uint32_t | parityY (void) const
Protected Attributes inherited from grk::grk_buf< T, A >
T * | buf
size_t | offset
size_t | len
bool | owns_data
Protected Attributes inherited from grk::grk_rect< uint32_t >
bool | absoluteCoordinates
uint32_t | origin_x0
uint32_t | origin_y0
uint32_t | x0
uint32_t | y0
uint32_t | x1
uint32_t | y1

## Constructor & Destructor Documentation

## grk_buf2d() [1/7]

template<typename T , template< typename TT > typename A>

grk::grk_buf2d< T, A >::grk_buf2d | ( | T * | buffer,
|  | bool | ownsData,
|  | uint32_t | w,
|  | uint32_t | strd,
|  | uint32_t | h
| ) |  |

inline

## grk_buf2d() [2/7]

template<typename T , template< typename TT > typename A>

grk::grk_buf2d< T, A >::grk_buf2d | ( | uint32_t | w,
|  | uint32_t | h
| ) |  |

inline

## grk_buf2d() [3/7]

template<typename T , template< typename TT > typename A>

grk::grk_buf2d< T, A >::grk_buf2d | ( | const grk_rect32 * | b | ) |

inline explicit

## grk_buf2d() [4/7]

template<typename T , template< typename TT > typename A>

grk::grk_buf2d< T, A >::grk_buf2d | ( | const grk_rect32 & | b | ) |

inline explicit

## grk_buf2d() [5/7]

template<typename T , template< typename TT > typename A>

grk::grk_buf2d< T, A >::grk_buf2d | ( | const grk_rect32 & | b,
|  | bool | useOrigin
| ) |  |

inline

## grk_buf2d() [6/7]

template<typename T , template< typename TT > typename A>

grk::grk_buf2d< T, A >::grk_buf2d | ( | void |  | ) |

inline

## grk_buf2d() [7/7]

template<typename T , template< typename TT > typename A>

grk::grk_buf2d< T, A >::grk_buf2d | ( | const grk_buf2d< T, A > & | rhs | ) |

inline explicit

## ~grk_buf2d()

template<typename T , template< typename TT > typename A>

virtual grk::grk_buf2d< T, A >::~grk_buf2d | ( |  | ) |

virtual default

## Member Function Documentation

## acquire()

template<typename T , template< typename TT > typename A>

void grk::grk_buf2d< T, A >::acquire | ( | T * | buffer,
|  | uint32_t | strd
| ) |  |

inline

References grk::grk_buf< T, A >::acquire(), grk::grk_read(), and grk::grk_buf2d< T, A >::stride.

## address()

template<typename T , template< typename TT > typename A>

T * grk::grk_buf2d< T, A >::address | ( | uint32_t | x,
|  | uint32_t | y
| ) |  |

inline

References grk::grk_buf< T, A >::currPtr(), grk::grk_read(), and grk::grk_buf2d< T, A >::stride.

Referenced by grk::grk_buf2d< T, A >::attach().

## alloc2d()

template<typename T , template< typename TT > typename A>

bool grk::grk_buf2d< T, A >::alloc2d | ( | bool | clear | ) |

inline

References grk::grk_buf< T, A >::buf, grk::GRK_ERROR(), grk::grk_make_aligned_width(), grk::grk_read(), grk::grk_rect< uint32_t >::height(), grk::grk_buf2d< T, A >::stride, and grk::grk_rect< uint32_t >::width().

Referenced by grk::ResWindow< T >::alloc().

## attach() [1/5]

template<typename T , template< typename TT > typename A>

void grk::grk_buf2d< T, A >::attach | ( | grk_buf2d< T, A > & | rhs | ) |

inline

References grk::grk_buf2d< T, A >::attach(), and grk::grk_read().

## attach() [2/5]

template<typename T , template< typename TT > typename A>

void grk::grk_buf2d< T, A >::attach | ( | grk_buf2d< T, A > & | rhs,
|  | uint32_t | x,
|  | uint32_t | y
| ) |  |

inline

References grk::grk_buf2d< T, A >::attach(), and grk::grk_read().

## attach() [3/5]

template<typename T , template< typename TT > typename A>

void grk::grk_buf2d< T, A >::attach | ( | grk_buf2d< T, A > * | rhs | ) |

inline

References grk::grk_buf2d< T, A >::attach(), and grk::grk_read().

## attach() [4/5]

template<typename T , template< typename TT > typename A>

void grk::grk_buf2d< T, A >::attach | ( | grk_buf2d< T, A > * | rhs,
|  | uint32_t | x,
|  | uint32_t | y
| ) |  |

inline

References grk::grk_buf2d< T, A >::address(), grk::grk_buf< T, A >::buf, grk::grk_buf< T, A >::dealloc(), grk::grk_read(), grk::grk_buf< T, A >::len, grk::grk_buf< T, A >::owns_data, and grk::grk_buf2d< T, A >::stride.

## attach() [5/5]

template<typename T , template< typename TT > typename A>

void grk::grk_buf2d< T, A >::attach | ( | T * | buffer,
|  | uint32_t | strd
| ) |  |

inline

References grk::grk_buf< T, A >::attach(), grk::grk_read(), and grk::grk_buf2d< T, A >::stride.

Referenced by grk::ResWindow< T >::alloc(), grk::grk_buf2d< T, A >::attach(), grk::grk_buf2d< T, A >::attach(), grk::grk_buf2d< T, A >::attach(), and grk::TileComponentWindow< T >::attach().

## copyFrom() [1/3]

template<typename T , template< typename TT > typename A>

void grk::grk_buf2d< T, A >::copyFrom | ( | const grk_buf2d< T, A > & | src | ) |

inline

References grk::grk_read().

## copyFrom() [2/3]

template<typename T , template< typename TT > typename A>
template<typename F >

void grk::grk_buf2d< T, A >::copyFrom | ( | const grk_buf2d< T, A > & | src,
|  | F | filter
| ) |  |

inline

References grk::grk_buf2d< T, A >::copyFrom(), and grk::grk_read().

Referenced by grk::grk_buf2d< T, A >::copyFrom().

## copyFrom() [3/3]

template<typename T , template< typename TT > typename A>
template<typename F >

void grk::grk_buf2d< T, A >::copyFrom | ( | const grk_buf2d< T, A > * | src,
|  | F | filter
| ) |  |

inline

References grk::grk_buf< T, A >::buf, grk::grk_read(), grk::grk_rect< uint32_t >::intersection(), grk::grk_buf< T, A >::len, and grk::grk_buf2d< T, A >::stride.

## getBuffer()

template<typename T , template< typename TT > typename A>

T * grk::grk_buf2d< T, A >::getBuffer | ( | void |  | ) | const

inline

References grk::grk_buf< T, A >::currPtr().

## isWindowValid()

template<typename T , template< typename TT > typename A>

bool grk::grk_buf2d< T, A >::isWindowValid | ( | grk_rect32 | win | ) |

inline

Returns whether window bounds are valid (non empty and within buffer bounds)

Parameters

  win | window.

Returns
  true or false.

References grk::grk_read(), grk::grk_rect< uint32_t >::x0, grk::grk_rect< uint32_t >::x1, and grk::grk_rect< uint32_t >::y1.

## operator=() [1/2]

template<typename T , template< typename TT > typename A>

grk_buf2d & grk::grk_buf2d< T, A >::operator= | ( | const grk_buf2d< T, A > & | rhs | ) |

inline

References grk::grk_read(), and grk::grk_buf2d< T, A >::operator=().

Referenced by grk::grk_buf2d< T, A >::operator=().

## operator=() [2/2]

template<typename T , template< typename TT > typename A>

grk_buf2d & grk::grk_buf2d< T, A >::operator= | ( | const grk_buf2d< T, A > * | rhs | ) |

inline

References grk::grk_read(), grk::grk_buf< T, A >::operator=(), grk::grk_rect< uint32_t >::operator=(), and grk::grk_buf2d< T, A >::stride.

## simple()

template<typename T , template< typename TT > typename A>

grk_buf2d_simple< T > grk::grk_buf2d< T, A >::simple | ( | void |  | ) | const

inline

References grk::grk_buf< T, A >::buf, grk::grk_read(), grk::grk_rect< uint32_t >::height(), and grk::grk_buf2d< T, A >::stride.

Referenced by grk::TileComponentWindow< T >::getResWindowBufferHighestSimple(), grk::TileComponentWindow< T >::getResWindowBufferSimple(), grk::ResWindow< T >::getResWindowBufferSimple(), and grk::TileComponentWindow< T >::getResWindowBufferSplitSimple().

## simpleF()

template<typename T , template< typename TT > typename A>

grk_buf2d_simple< float > grk::grk_buf2d< T, A >::simpleF | ( | void |  | ) | const

inline

References grk::grk_buf< T, A >::buf, grk::grk_read(), grk::grk_rect< uint32_t >::height(), and grk::grk_buf2d< T, A >::stride.

Referenced by grk::TileComponentWindow< T >::getResWindowBufferHighestSimpleF(), grk::TileComponentWindow< T >::getResWindowBufferSimpleF(), grk::ResWindow< T >::getResWindowBufferSimpleF(), and grk::TileComponentWindow< T >::getResWindowBufferSplitSimpleF().

## transfer()

template<typename T , template< typename TT > typename A>

void grk::grk_buf2d< T, A >::transfer | ( | T ** | buffer,
|  | uint32_t * | strd
| ) |  |

inline

References grk::grk_read(), grk::grk_buf2d< T, A >::stride, and grk::grk_buf< T, A >::transfer().

Referenced by grk::TileComponentWindow< T >::transfer().

## Member Data Documentation

## stride

template<typename T , template< typename TT > typename A>

uint32_t grk::grk_buf2d< T, A >::stride

Referenced by grk::grk_buf2d< T, A >::acquire(), grk::grk_buf2d< T, A >::address(), grk::grk_buf2d< T, A >::alloc2d(), grk::grk_buf2d< T, A >::attach(), grk::grk_buf2d< T, A >::attach(), grk::grk_buf2d< T, A >::copyFrom(), grk::TileComponentWindow< T >::getResWindowBufferHighestStride(), grk::grk_buf2d< T, A >::operator=(), grk::grk_buf2d< T, A >::simple(), grk::grk_buf2d< T, A >::simpleF(), and grk::grk_buf2d< T, A >::transfer().

The documentation for this struct was generated from the following file:

- buffer.h